## eiskaltdcpp 2.0.3

=== CMakeLists.txt ===
project (eiskaltdcpp)
cmake_minimum_required (VERSION 2.6)
set (PROJECT_NAME_GLOBAL eiskaltdcpp)

set (VERSION "2.0.x")
include (CheckIncludeFile)
include (CheckIncludeFiles)
include (CheckFunctionExists)
include (FindPkgConfig)
include (CheckCXXSourceCompiles)

#IF (GPTOOLS_CPU AND GPTOOLS_MEM)
#    SET (GPTOOLS_CPU FALSE)
#    SET (GPTOOLS_MEM FALSE)
#    SET (GPTOOLS_CPU_AND_MEM TRUE)
#ENDIF (GPTOOLS_CPU AND GPTOOLS_MEM)
#IF (GPTOOLS_MEM)
#    MESSAGE (STATUS "Enabled memory profiling via Google perftools")
#    SET (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -ltcmalloc")
#    SET (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ltcmalloc")
#ENDIF (GPTOOLS_MEM)
#IF (GPTOOLS_CPU)
#    MESSAGE (STATUS "Enabled CPU profiling via Google perftools")
#    SET (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lprofiler")
#    SET (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lprofiler")
#ENDIF (GPTOOLS_CPU)
#IF (GPTOOLS_CPU_AND_MEM)
#    MESSAGE (STATUS "Enabled both CPU and memory profiling via Google perftools")
#    SET (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -ltcmalloc_and_profiler")
#    SET (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ltcmalloc_and_profiler")
#ENDIF (GPTOOLS_CPU_AND_MEM)

if (ICONV_INCLUDE_DIR AND ICONV_LIBRARIES)
  # Already in cache, be silent
  set(ICONV_FIND_QUIETLY TRUE)
endif (ICONV_INCLUDE_DIR AND ICONV_LIBRARIES)

find_path(ICONV_INCLUDE_DIR iconv.h)

find_library(ICONV_LIBRARIES NAMES iconv libiconv libiconv-2 c)

if (ICONV_INCLUDE_DIR AND ICONV_LIBRARIES)
   set (ICONV_FOUND TRUE)
endif (ICONV_INCLUDE_DIR AND ICONV_LIBRARIES)

set(CMAKE_REQUIRED_INCLUDES ${ICONV_INCLUDE_DIR})
set(CMAKE_REQUIRED_LIBRARIES ${ICONV_LIBRARIES})

if (ICONV_FOUND)
  check_cxx_source_compiles("
  #include <iconv.h>
  int main(){
    iconv_t conv = 0;
    const char* in = 0;
    size_t ilen = 0;
    char* out = 0;
    size_t olen = 0;
    iconv(conv, &in, &ilen, &out, &olen);
    return 0;
  }
" ICONV_SECOND_ARGUMENT_IS_CONST )
endif (ICONV_FOUND)

set (CMAKE_REQUIRED_INCLUDES)
set (CMAKE_REQUIRED_LIBRARIES)

if (ICONV_FOUND)
  if (NOT ICONV_FIND_QUIETLY)
    message (STATUS "Found Iconv: ${ICONV_LIBRARIES}")
  endif (NOT ICONV_FIND_QUIETLY)
else (ICONV_FOUND)
  if (Iconv_FIND_REQUIRED)
    message (FATAL_ERROR "Could not find Iconv")
  endif (Iconv_FIND_REQUIRED)
endif (ICONV_FOUND)

MARK_AS_ADVANCED(
  ICONV_INCLUDE_DIR
  ICONV_LIBRARIES
  ICONV_SECOND_ARGUMENT_IS_CONST
)

CHECK_INCLUDE_FILE (malloc.h HAVE_MALLOC_H)
CHECK_INCLUDE_FILE (dlfcn.h HAVE_DLFCN_H)
CHECK_INCLUDE_FILE (inttypes.h HAVE_INTTYPES_H)
CHECK_FUNCTION_EXISTS(mallinfo HAVE_MALLINFO)
CHECK_FUNCTION_EXISTS(malloc_stats HAVE_MALLOC_STATS)
CHECK_FUNCTION_EXISTS(malloc_trim HAVE_MALLOC_TRIM)
CHECK_INCLUDE_FILE (memory.h HAVE_MEMORY_H)
CHECK_INCLUDE_FILE (stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILE (stdlib.h HAVE_STDLIB_H)
CHECK_INCLUDE_FILE (stdbool.h HAVE_STDBOOL_H)
CHECK_INCLUDE_FILE (strings.h HAVE_STRINGS_H)
CHECK_INCLUDE_FILE (sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE (sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE (limits.h HAVE_LIMITS_H)
CHECK_INCLUDE_FILE (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILE (sys/socket.h HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILE (ifaddrs.h HAVE_IFADDRS_H)
CHECK_INCLUDE_FILE (net/if.h HAVE_NET_IF_H)
CHECK_INCLUDE_FILE (sys/statvfs.h STAT_STATVFS)
CHECK_INCLUDE_FILES ("sys/socket.h;net/if.h;ifaddrs.h;sys/types.h" HAVE_ADDRS_H)
CHECK_INCLUDE_FILES ("sys/types.h;sys/statvfs.h;limits.h;stdbool.h;stdint.h" FS_USAGE_C)

find_package (BZip2 REQUIRED)
find_package (ZLIB REQUIRED)
find_package (OpenSSL REQUIRED)
find_package (Threads REQUIRED)
find_package (Gettext REQUIRED)

option (USE_JS "QtScript support")
if (NOT USE_JS)
  find_package (Qt4 4.4 COMPONENTS QtCore QtGui QtXml QtNetwork QtDBus REQUIRED)
else (NOT USE_JS)
  find_package (Qt4 4.4 COMPONENTS QtCore QtGui QtXml QtNetwork QtDBus QtScript REQUIRED)
endif (NOT USE_JS)

find_package (PkgConfig)

if (NOT USE_ASPELL)
    option(USE_ASPELL "Use aspell for spellchecking")
    if(USE_ASPELL EQUAL 0)
    else(USE_ASPELL EQUAL 0)
        find_package (ASPELL)
        if (ASPELL_FOUND)
            set (USE_ASPELL 1 CACHE BOOL "Use aspell for spellchecking" FORCE)
        endif (ASPELL_FOUND)
    endif(USE_ASPELL EQUAL 0)
endif (NOT USE_ASPELL)

if (USE_ASPELL)
  find_package (ASPELL REQUIRED)
  message (STATUS "Building with Aspell support")
else (USE_ASPELL)
  message (STATUS "Building without Aspell support")
endif (USE_ASPELL)

#if (NOT (LOCAL_BOOST EQUAL 0))
#set (LOCAL_BOOST 1)
#endif (NOT (LOCAL_BOOST EQUAL 0))

option (FORCE_XDG "Respect freedesktop.org standards" ON)

option (FREE_SPACE_BAR "Use for show free space on volume boost libs")
option (FREE_SPACE_BAR_C "Use for show free space on volume small c lib")
if (FREE_SPACE_BAR AND NOT FREE_SPACE_BAR_C)
if (NOT LOCAL_BOOST)
find_package (Boost COMPONENTS date_time filesystem system REQUIRED)
message (STATUS "Build with free space bar (boost)")
else (NOT LOCAL_BOOST)
message (STATUS "Sorry, you add flag when use boost libs with flag when change ")
message (STATUS "local boost headers, may build this config only with free space bar (c realized)")
set (FREE_SPACE_BAR_C 1 CACHE BOOL "Use for show free space on volume small c lib" FORCE)
set (FREE_SPACE_BAR 0 CACHE BOOL "Use for show free space on volume boost libs" FORCE)
endif (NOT LOCAL_BOOST)
endif (FREE_SPACE_BAR AND NOT FREE_SPACE_BAR_C)

if (FREE_SPACE_BAR_C AND NOT FREE_SPACE_BAR)
set (FREE_SPACE_BAR_C 1 CACHE BOOL "Use for show free space on volume small c lib" FORCE)
if (NOT LOCAL_BOOST)
find_package (Boost REQUIRED)
endif (NOT LOCAL_BOOST)
message (STATUS "Build with free space bar (realisation on C, POSIX 1003.1-2001 (and later) with XSI)")
endif (FREE_SPACE_BAR_C AND NOT FREE_SPACE_BAR)

if (FREE_SPACE_BAR AND FREE_SPACE_BAR_C)
set (FREE_SPACE_BAR 0 CACHE BOOL "Use for show free space on volume boost libs" FORCE)
set (FREE_SPACE_BAR_C 1 CACHE BOOL "Use for show free space on volume small c lib" FORCE)
if (NOT LOCAL_BOOST)
find_package (Boost REQUIRED)
endif (NOT LOCAL_BOOST)
message (STATUS "Build with free space bar (realisation on C, POSIX 1003.1-2001 (and later) with XSI)")
endif (FREE_SPACE_BAR AND FREE_SPACE_BAR_C)

if (NOT FREE_SPACE_BAR AND NOT FREE_SPACE_BAR_C)
set (FREE_SPACE_BAR 0 CACHE BOOL "Use for show free space on volume boost libs" FORCE)
set (FREE_SPACE_BAR_C 0 CACHE BOOL "Use for show free space on volume small c lib" FORCE)
if (NOT LOCAL_BOOST)
find_package (Boost REQUIRED)
endif (NOT LOCAL_BOOST)
message (STATUS "Build without free space bar")
endif (NOT FREE_SPACE_BAR AND NOT FREE_SPACE_BAR_C)

if (LOCAL_BOOST)
file(GLOB BOOST_TAR_EXISTS  *.tar.gz)
if (NOT BOOST_TAR_EXISTS)
set (boost_file_name "boost.tar.gz")
file(DOWNLOAD http://eiskaltdc.googlecode.com/files/${boost_file_name} ${CMAKE_CURRENT_SOURCE_DIR}/${boost_file_name} LOG boost_logs STATUS boost_status)
message (STATUS "${boost_logs}")
message (STATUS "${boost_status}")
endif (NOT BOOST_TAR_EXISTS)
file(GLOB BOOST_TAR_EXISTS  *.tar.gz)
FIND_PROGRAM (TAR_CMD tar)
  EXECUTE_PROCESS (
                COMMAND ${TAR_CMD} -xf ${BOOST_TAR_EXISTS}
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/)
set (Boost_INCLUDEDIR "./")
message (STATUS "USED LOCAL BOOST HEADERS")
endif(LOCAL_BOOST)

pkg_check_modules (PC_UPNP REQUIRED libupnp)

set (UPNP_DEFINITIONS ${PC_UPNP_CFLAGS_OTHER})

find_path(UPNP_INCLUDE_DIR upnp/upnp.h
   HINTS
   ${PC_UPNP_INCLUDEDIR}
   ${PC_UPNP_INCLUDE_DIRS}
   PATH_SUFFIXES upnp)
find_library(UPNP_UPNP_LIBRARY upnp
   HINTS
   ${PC_UPNP_LIBDIR}
   ${PC_UPNP_LIBRARY_DIRS})
find_library(UPNP_IXML_LIBRARY ixml
   HINTS
   ${PC_UPNP_LIBDIR}
   ${PC_UPNP_LIBRARY_DIRS})
find_library(UPNP_THREADUTIL_LIBRARY threadutil
   HINTS
   ${PC_UPNP_LIBDIR}
   ${PC_UPNP_LIBRARY_DIRS})

if (UPNP_INCLUDE_DIR AND UPNP_UPNP_LIBRARY)
    set (UPNP_FOUND 1)
endif (UPNP_INCLUDE_DIR AND UPNP_UPNP_LIBRARY)

if (UPNP_FOUND)
    set (UPNP_LIBRARY ${UPNP_UPNP_LIBRARY} ${UPNP_IXML_LIBRARY} ${UPNP_THREADUTIL_LIBRARY} ${PC_UPNP_LDFLAGS})
    message (STATUS "Found the upnp libraries at ${UPNP_LIBRARY}")
    message (STATUS "Found the upnp headers at ${UPNP_INCLUDE_DIR}")
else (UPNP_FOUND)
    message (STATUS "Could not find upnp")
endif (UPNP_FOUND)

if (NOT CMAKE_INSTALL_PREFIX)
  set (CMAKE_INSTALL_PREFIX "/usr")
endif (NOT CMAKE_INSTALL_PREFIX)

if (LIB_INSTALL_DIR)
  set (LIBDIR ${LIB_INSTALL_DIR})
endif (LIB_INSTALL_DIR)

if (NOT LIBDIR)
  set (LIBDIR "lib")
  message (STATUS "Library directory: ${CMAKE_INSTALL_PREFIX}/${LIBDIR}")
endif (NOT LIBDIR)

if (NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE "RelWithDebInfo")
endif (NOT CMAKE_BUILD_TYPE)

if (UNIX AND NOT APPLE)
  set (DATAPATH "share/eiskaltdcpp")
elseif (APPLE)
  set (DATAPATH "./")
endif (UNIX AND NOT APPLE)

set (SHARE_DIR "share")

if (APPLE)
  set (CLIENT_DATA_DIR "${PROJECT_NAME_GLOBAL}.app")
else (APPLE)
  set (CLIENT_DATA_DIR "${CMAKE_INSTALL_PREFIX}/${SHARE_DIR}/${PROJECT_NAME_GLOBAL}")
endif (APPLE)

set (_DATADIR "${CLIENT_DATA_DIR}")

message (STATUS "Data directory: ${CLIENT_DATA_DIR}")

if (NOT DEFINED SVNVERSION)
        find_program (SVNVERSION_CMD svnversion)
        execute_process (COMMAND "${SVNVERSION_CMD}"
                OUTPUT_VARIABLE SVNVERSION
                OUTPUT_STRIP_TRAILING_WHITESPACE)
        message (STATUS "Build svn revision: ${SVNVERSION}")
endif (NOT DEFINED SVNVERSION)
if (NOT SVNVERSION OR SVNVERSION STREQUAL exported)
else (SVNVERSION)
        add_definitions(-DDCPP_REVISION="\(r""${SVNVERSION}""\)")
endif (NOT SVNVERSION OR SVNVERSION STREQUAL exported)
if (UNIX)
add_definitions (-D_GNU_SOURCE -D_LARGEFILE_SOURCE)
endif (UNIX)

set (CLIENT_TRANSLATIONS_DEST "${CLIENT_DATA_DIR}/ts")
set (CLIENT_SOUNDS_DEST "${CLIENT_DATA_DIR}/sounds")
set (CLIENT_ICONS_DEST "${CLIENT_DATA_DIR}/icons")
set (CLIENT_SCRIPTS_DEST "${CLIENT_DATA_DIR}/scripts")

add_definitions (-pipe -O2 -I. -fno-builtin -D_FILE_OFFSET_BITS=64
                 -D_REENTRANT -D_DATADIR="${_DATADIR}"
                 -DNDEBUG -DBUILDING_DCPP)

if (HAVE_IFADDRS_H)
  add_definitions (-DHAVE_IFADDRS_H -DHAVE_IF_ADDRS_H)
endif (HAVE_IFADDRS_H)

if (ICONV_SECOND_ARGUMENT_IS_CONST)
  add_definitions (-DICONV_CONST=const)
endif (ICONV_SECOND_ARGUMENT_IS_CONST)

if (FORCE_XDG)
  add_definitions (-DFORCE_XDG)
endif (FORCE_XDG)

if (USE_JS)
  add_definitions (-DUSE_JS)
endif (USE_JS)

if (USE_ICON_THEME)
 add_definitions(-DUSE_ICON_THEME )
endif (USE_ICON_THEME)

set(CMAKE_CXX_FLAGS_RELEASE     "-DNDEBUG -DQT_NO_DEBUG -O3 -fomit-frame-pointer -pipe")
set(CMAKE_CXX_FLAGS_DEBUG       "-UNDEBUG -g3 -pipe")

include_directories(${eiskaltdcpp_BINARY_DIR}
   ${eiskaltdcpp_BINARY_DIR}/dcpp
   ${eiskaltdcpp_SOURCE_DIR}/dcpp
   ${eiskaltdcpp_BINARY_DIR}/eiskaltdcpp
   ${eiskaltdcpp_SOURCE_DIR}/eiskaltdcpp
   ${eiskaltdcpp_SOURCE_DIR}
   ${GMP_INCLUDE_DIR}
   )
message(STATUS "CMAKE will use this libs(and headers) during build:

                upnp (headers): ${UPNP_LIBRARY} (${UPNP_INCLUDE_DIR})
                boost (headers): ${Boost_LIBRARIES} (${Boost_INCLUDE_DIR})
                bzip2 (headers): ${BZIP2_LIBRARIES} (${BZIP2_INCLUDE_DIR})
                zlib (headers): ${ZLIB_LIBRARIES} (${ZLIB_INCLUDE_DIR})
                openssl (headers): ${OPENSSL_LIBRARIES} (${OPENSSL_INCLUDE_DIR})
                iconv (headers): ${ICONV_LIBRARIES} (${ICONV_INCLUDE_DIR})
                aspell (headers): ${ASPELL_LIBRARIES} (${ASPELL_INCLUDE_DIR})
                ")

add_subdirectory (dcpp)
add_subdirectory (eiskaltdcpp)
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== dcpp/CMakeLists.txt ===
project (dcpp)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

cmake_minimum_required (VERSION 2.6)
aux_source_directory(${PROJECT_SOURCE_DIR} dcpp_srcs)
if (HAVE_ADDRS_H EQUAL 1)
  add_definitions (-DHAVE_IFADDRS_H)
endif (HAVE_ADDRS_H EQUAL 1)
include_directories (${Boost_INCLUDE_DIR} ${BZIP2_INCLUDE_DIR} ${ZLIB_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR})
add_library (dcpp STATIC ${dcpp_srcs})
target_link_libraries (dcpp ${BZIP2_LIBRARIES} ${ZLIB_LIBRARIES} ${OPENSSL_LIBRARIES})

=== eiskaltdcpp/CMakeLists.txt ===
project (eiskaltdcpp)
cmake_minimum_required (VERSION 2.6)
if (FREE_SPACE_BAR_C)
add_subdirectory(gnulib)
endif (FREE_SPACE_BAR_C)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set (QT_USE_QTNETWORK 1)
set (QT_USE_QTXML 1)
set (QT_USE_QTDBUS 1)

if (USE_JS)
  set (QT_USE_QTSCRIPT  1)
endif (USE_JS)

include (${QT_USE_FILE})
set (HDRS   ArenaWidgetContainer.h
            EmoticonObject.h
            Func.h
            HistoryInterface.h
            PMWindow.h
            PoolAlloc.h
            Version.h)
set (SRCS
            ADLS.cpp
            ADLSModel.cpp
            Antispam.cpp
            AntiSpamFrame.cpp
            ArenaWidget.cpp
            ArenaWidgetContainer.cpp
            CustomFontModel.cpp
            DownloadQueue.cpp
            DownloadQueueModel.cpp
            EmoticonDialog.cpp
            EmoticonFactory.cpp
            FavoriteHubModel.cpp
            FavoriteHubs.cpp
            FavoriteUsers.cpp
            FavoriteUsersModel.cpp
            FileBrowserModel.cpp
            FinishedTransfers.cpp
            FinishedTransfersModel.cpp
            HashProgress.cpp
            HubFrame.cpp
            HubManager.cpp
            IPFilter.cpp
            IPFilterFrame.cpp
            IPFilterModel.cpp
            LineEdit.cpp
            Magnet.cpp
            MainWindow.cpp
            Notification.cpp
            PMWindow.cpp
            PublicHubs.cpp
            PublicHubsList.cpp
            PublicHubModel.cpp
            QuickConnect.cpp
            SearchFrame.cpp
            SearchModel.cpp
            Settings.cpp
            SettingsConnection.cpp
            SettingsDownloads.cpp
            SettingsGUI.cpp
            SettingsLog.cpp
            SettingsNotification.cpp
            SettingsPersonal.cpp
            SettingsSharing.cpp
            SettingsUC.cpp
            ShareBrowser.cpp
            ShellCommandRunner.cpp
            SideBar.cpp
            SingleInstanceRunner.cpp
            SpyFrame.cpp
            SpyModel.cpp
            ToolBar.cpp
            TransferView.cpp
            TransferViewModel.cpp
            UCModel.cpp
            UPnP.cpp
            UPnPMapper.cpp
            UserListModel.cpp
            WulforSettings.cpp
            WulforUtil.cpp
            ChatEdit.cpp)
set (MOC_HDRS
            ADLS.h
            ADLSModel.h
            Antispam.h
            AntiSpamFrame.h
	    ArenaWidget.h
            CustomFontModel.h
            DownloadQueue.h
            DownloadQueueModel.h
            EmoticonDialog.h
            EmoticonFactory.h
            FavoriteHubModel.h
            FavoriteHubs.h
            FavoriteUsers.h
            FavoriteUsersModel.h
            FileBrowserModel.h
            FinishedTransfers.h
            FinishedTransfersModel.h
            HashProgress.h
            HubFrame.h
            HubManager.h
            IPFilter.h
            IPFilterFrame.h
            IPFilterModel.h
            LineEdit.h
            Magnet.h
            MainWindow.h
            Notification.h
            PMWindow.h
            PublicHubs.h
            PublicHubsList.h
            PublicHubModel.h
            Settings.h
            SettingsConnection.h
            SettingsDownloads.h
            SettingsGUI.h
            SettingsLog.h
            SettingsNotification.h
            SettingsPersonal.h
            SettingsSharing.h
            SettingsUC.h
            SideBar.h
            SingleInstanceRunner.h
            QuickConnect.h
            SearchFrame.h
            SearchModel.h
            ShareBrowser.h
            ShellCommandRunner.h
            SpyFrame.h
            SpyModel.h
            ToolBar.h
            TransferView.h
            TransferViewModel.h
            UCModel.h
            UPnP.h
            UPnPMapper.h
            UserListModel.h
            WulforSettings.h
            WulforUtil.h
            ChatEdit.h)
set (UI_FORMS ui/UIAbout.ui
            ui/UIAntiSpam.ui
            ui/UIADLSearch.ui
            ui/UIADLSearchEditor.ui
            ui/HubFrame.ui
            ui/PrivateMessage.ui
            ui/UIDownloadQueue.ui
            ui/UIFavoriteHubs.ui
            ui/UIFavoriteHubEditor.ui
            ui/UIFavoriteUsers.ui
            ui/UIFinishedTransfers.ui
            ui/UIHashProgressDialog.ui
            ui/UIIPFilter.ui
            ui/UIMagnet.ui
            ui/UIPublicHubs.ui
            ui/UIPublicHubsList.ui
            ui/UIQuickConnect.ui
            ui/UISearchFrame.ui
            ui/UISettings.ui
            ui/UISettingsConnection.ui
            ui/UISettingsDownloads.ui
            ui/UISettingsGUI.ui
            ui/UISettingsLog.ui
            ui/UISettingsNotification.ui
            ui/UISettingsPersonal.ui
            ui/UISettingsSharing.ui
            ui/UIShareBrowser.ui
            ui/UISpy.ui
            ui/UITransferView.ui
            ui/UISettingsUC.ui
            ui/UIUserCommands.ui
	    ui/UIScriptManager.ui
	    ui/UIDialogScriptConsole.ui
            )

option(LANGUAGES "Using translations")

if (NOT linguas)
  set (LANGUAGES be en fr hu pl ru sr uk CACHE STRING "Using translations" FORCE)
else (NOT linguas)
  string(REGEX MATCHALL [a-zA-Z]+
         linguas1 ${linguas})
  #message(STATUS ${linguas1})
  set (LANGUAGES ${linguas1} CACHE STRING "Using translations" FORCE)
endif (NOT linguas)

if (USE_ASPELL)
  set (SRCS ${SRCS} SpellCheck.cpp)
  set (MOC_HDRS ${MOC_HDRS} SpellCheck.h)
endif (USE_ASPELL)

if (USE_JS)
  set (SRCS ${SRCS}
	    scriptengine/ClientManagerScript.cpp
	    scriptengine/HashManagerScript.cpp
	    scriptengine/LogManagerScript.cpp
	    scriptengine/MainWindowScript.cpp
	    scriptengine/ScriptConsole.cpp
	    scriptengine/ScriptEngine.cpp
	    scriptengine/ScriptConsole.cpp
	    ScriptManagerDialog.cpp)
  set (MOC_HDRS ${MOC_HDRS}
		scriptengine/ClientManagerScript.h
		scriptengine/HashManagerScript.h
		scriptengine/LogManagerScript.h
		scriptengine/MainWindowScript.h
		scriptengine/ScriptConsole.h
		scriptengine/ScriptEngine.h
		scriptengine/ScriptConsole.h
		ScriptManagerDialog.h)
endif (USE_JS)

foreach (LANGUAGE ${LANGUAGES})
  set (COMPILED_TRANSLATIONS ${COMPILED_TRANSLATIONS} ${CMAKE_CURRENT_SOURCE_DIR}/translations/eiskaltdcpp.${LANGUAGE}.qm)
  #message (STATUS ${COMPILED_TRANSLATIONS})
endforeach()

#Create moc files
QT4_WRAP_CPP (M_SRCS ${MOC_HDRS})
#Create .h files from ui files
QT4_WRAP_UI (U_SRCS ${UI_FORMS})
#Create translations
foreach (LANGUAGE ${LANGUAGES})
        set (TS ${CMAKE_CURRENT_SOURCE_DIR}/translations/eiskaltdcpp.${LANGUAGE}.ts)
        set (QM ${CMAKE_CURRENT_SOURCE_DIR}/translations/eiskaltdcpp.${LANGUAGE}.qm)
        set (TRANSLATIONS ${TRANSLATIONS} ${TS})
        set (TRANSLATIONS_BINARY ${TRANSLATIONS_BINARY} ${QM})
        add_custom_command (
                OUTPUT ${QM}
                COMMAND ${QT_LRELEASE_EXECUTABLE} ${TS}
                MAIN_DEPENDENCY ${TS})
endforeach()

set (DEFAULT_QRC_FILE ${CMAKE_CURRENT_SOURCE_DIR}/icons/appl/default/default.qrc)

add_custom_target (
        translations_qt
        COMMAND ${QT_LUPDATE_EXECUTABLE} ${HEADERS} ${SOURCES} -ts ${TRANSLATIONS})
add_custom_command (
        TARGET translations_qt
        COMMAND ${QT_LRELEASE_EXECUTABLE} ${TRANSLATIONS})

if (UNIX)
  FIND_PROGRAM (GZIP_CMD gzip)
  EXECUTE_PROCESS (
                OUTPUT_FILE eiskaltdcpp.1.gz
                COMMAND "${GZIP_CMD}" -9
                INPUT_FILE eiskaltdcpp.1
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/)
endif (UNIX)

if (UNIX)
  EXECUTE_PROCESS (
    COMMAND ${QT_RCC_EXECUTABLE} -binary  ${DEFAULT_QRC_FILE} -o default.rcc
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
  )
endif (UNIX)

include_directories (${QT_INCLUDES} ${UPNP_INCLUDE_DIR} ${PROJECT_SOURCE_DIR}  "${PROJECT_SOURCE_DIR}/scriptengine" ${PROJECT_SOURCE_DIR}/.. ${Boost_INCLUDE_DIRS})
set (LIBS ${LIBS} ${QT_LIBRARIES} ${UPNP_LIBRARY} ${Boost_LIBRARIES} ${ICONV_LIBRARIES})

if (FREE_SPACE_BAR AND NOT FREE_SPACE_BAR_C)
  add_definitions (-DFREE_SPACE_BAR)
  set (LIBS ${LIBS} ${Boost_LIBRARIES})
endif (FREE_SPACE_BAR AND NOT FREE_SPACE_BAR_C)

if (FREE_SPACE_BAR_C AND NOT FREE_SPACE_BAR)
  add_definitions (-DFREE_SPACE_BAR_C)
  set (LIBS ${LIBS} gnu)
endif (FREE_SPACE_BAR_C AND NOT FREE_SPACE_BAR)

if (USE_ASPELL)
  add_definitions (-DUSE_ASPELL ${ASPELL_DEFINITIONS})
  include_directories (${ASPELL_INCLUDE_DIR})
  set (LIBS ${LIBS} ${ASPELL_LIBRARIES})
endif (USE_ASPELL)

if (APPLE)
  # set how it shows up in the Info.plist file
  SET(MACOSX_BUNDLE_ICON_FILE icon_128x128.icns)
  # set where in the bundle to put the icns file
  SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/icons/icon_128x128.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  # include the icns file in the target
  SET(SRCS ${SRCS} ${CMAKE_CURRENT_SOURCE_DIR}/icons/icon_128x128.icns)
endif (APPLE)

add_executable (eiskaltdcpp MACOSX_BUNDLE WIN32 main.cpp
                ${M_SRCS}
                ${U_SRCS}
                ${SRCS}
                ${HDRS}
                ${MOC_HDRS}
                ${TRANSLATIONS}
                translations
                )
add_definitions (-I. -I.. -DCLIENT_DATA_DIR="${CLIENT_DATA_DIR}"
                          -DCLIENT_SOUNDS_DIR="${CLIENT_SOUNDS_DEST}"
                          -DCLIENT_TRANSLATIONS_DIR="${CLIENT_TRANSLATIONS_DEST}"
                          -DCLIENT_ICONS_DIR="${CLIENT_ICONS_DEST}"
                )

if (USE_JS)
  add_definitions (-DCLIENT_SCRIPTS_DIR="${CLIENT_SCRIPTS_DEST}")
endif (USE_JS)

if (APPLE)
  add_definitions(        -DCLIENT_RES_DIR="${PROJECT_NAME_GLOBAL}.app/resources")
else (APPLE)
  add_definitions(        -DCLIENT_RES_DIR="${CLIENT_DATA_DIR}/resources")
endif (APPLE)

if (APPLE)
  target_link_libraries (eiskaltdcpp ${LIBS} dcpp iconv intl upnp ixml)
else (APPLE)
  target_link_libraries (eiskaltdcpp ${LIBS} dcpp)
endif (APPLE)

  set_property (TARGET eiskaltdcpp PROPERTY OUTPUT_NAME ${PROJECT_NAME_GLOBAL})
  install (TARGETS eiskaltdcpp
    RUNTIME DESTINATION bin
    BUNDLE DESTINATION . )

if (NOT APPLE)

  install (DIRECTORY icons/appl icons/emot icons/user DESTINATION ${CLIENT_ICONS_DEST} PATTERN ".svn" EXCLUDE)

  if (USE_JS)
    install (DIRECTORY scripts/ DESTINATION ${CLIENT_DATA_DIR}/scripts FILE_PERMISSIONS FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE PATTERN ".svn" EXCLUDE )
  endif (USE_JS)

  install (DIRECTORY examples/ DESTINATION ${CLIENT_DATA_DIR}/examples FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE PATTERN ".svn" EXCLUDE )
  install (FILES icons/icon_128x128.png DESTINATION share/icons/hicolor/128x128/apps RENAME eiskaltdcpp.png)
  install (FILES icons/icon_64x64.png DESTINATION share/icons/hicolor/64x64/apps RENAME eiskaltdcpp.png)
  install (FILES icons/icon_32x32.png DESTINATION share/icons/hicolor/32x32/apps RENAME eiskaltdcpp.png)
  install (FILES icons/icon_48x48.png DESTINATION share/icons/hicolor/48x48/apps RENAME eiskaltdcpp.png)
  install (FILES icons/icon_22x22.png DESTINATION share/icons/hicolor/22x22/apps RENAME eiskaltdcpp.png)
  install (FILES icons/icon_24x24.png DESTINATION share/icons/hicolor/24x24/apps RENAME eiskaltdcpp.png)
  install (FILES icons/icon_16x16.png DESTINATION share/icons/hicolor/16x16/apps RENAME eiskaltdcpp.png)
  install (FILES icons/icon_128x128.png DESTINATION share/pixmaps/ RENAME eiskaltdcpp.png)
  install (FILES ../eiskaltdcpp.desktop DESTINATION share/applications)
  install (FILES ${TRANSLATIONS_BINARY} DESTINATION ${CLIENT_TRANSLATIONS_DEST})
  install (FILES eiskaltdcpp.1.gz DESTINATION share/man/man1)
  install (FILES default.rcc DESTINATION ${CLIENT_DATA_DIR}/resources)

endif (NOT APPLE)

if (APPLE)

  INCLUDE( ${QT_USE_FILE} )

  set(plugin_dest_dir ${PROJECT_NAME_GLOBAL}.app/Contents/MacOS)
  set(qtconf_dest_dir ${PROJECT_NAME_GLOBAL}.app/Contents/Resources)
  set(APPS "\${CMAKE_INSTALL_PREFIX}/${PROJECT_NAME_GLOBAL}.app")

=== eiskaltdcpp/gnulib/CMakeLists.txt ===
PROJECT(gnu)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
# ######### General setup ##########
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR})
if (FS_USAGE_C)
add_definitions(-DFS_USAGE_C)
IF (NOT WIN32)
aux_source_directory(${PROJECT_SOURCE_DIR} gnulib_SRCS)
# actual target:
ADD_LIBRARY(gnu STATIC ${gnulib_SRCS})
ENDIF (NOT WIN32)
elseif (FS_USAGE_C)
message(STATUS "Sorry but this lib don't build without necessary headers")
endif (FS_USAGE_C)

=== debian/changelog ===
eiskaltdcpp (2.0.3-1) unstable; urgency=low

  * Update to stable release of EiskaltDC++ 2.0.3.

 -- Boris Pek <tehnick-8@mail.ru>  Tue, 08 Jun 2010 21:55:18 +0400

eiskaltdcpp (2.0.2-1) unstable; urgency=low

  * Update to stable release of EiskaltDC++ 2.0.2.

 -- Boris Pek <tehnick-8@mail.ru>  Thu, 13 May 2010 11:25:06 +0400

eiskaltdcpp (2.0.1-1) unstable; urgency=low

  * Initial release (closes: #540458).

 -- Boris Pek <tehnick-8@mail.ru>  Tue, 27 Apr 2010 01:40:10 +0400

=== debian/control ===
Source: eiskaltdcpp
Section: net
Priority: optional
Maintainer: Boris Pek <tehnick-8@mail.ru>
Build-Depends: debhelper (>= 7), cmake (>= 2.6.0), autotools-dev, fakeroot,
 libqt4-dev (>=4.4.0), qt4-dev-tools (>=4.4.0), qt4-qtconfig (>=4.4.0),
 libboost-dev | libboost1.42-dev | libboost1.40-dev | libboost1.39-dev | libboost1.38-dev | libboost1.37-dev | libboost1.35-dev,
 libbz2-dev, zlib1g-dev, pkg-config, libupnp3-dev, libssl-dev, libaspell-dev
Homepage: http://code.google.com/p/eiskaltdc/
Standards-Version: 3.8.4

Package: eiskaltdcpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: php5-cli
Replaces: eiskaltdcpp-unstable
Conflicts: eiskaltdcpp-unstable
Description: EiskaltDC++ is graphical client for Direct Connect
 EiskaltDC++ is a program for UNIX-like systems that uses the Direct Connect
 and ADC protocol. It is compatible with other DC clients, such as the original
 DC from Neomodus, DC++ and derivatives. EiskaltDC++ also interoperates with
 all common DC hub software.

=== debian/rules ===
#!/usr/bin/make -f

NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)

ifeq ($(NCPUS),-1)
	NCPUS:=1
endif

ifeq ($(NCPUS),0)
	NCPUS:=1
endif

PKG_NAME = eiskaltdcpp

CMAKEOPTS =	-DUSE_ASPELL:BOOL=1 \
			-DFREE_SPACE_BAR_C:BOOL=1 \
			-DCMAKE_INSTALL_PREFIX=/usr \
			./

configure: configure-stamp
configure-stamp:
	dh_testdir
	cmake $(CMAKEOPTS)
	cp ChangeLog.txt changelog
	touch $@
build: configure build-stamp
build-stamp:
	dh_testdir
	$(MAKE) -j$(NCPUS)
	touch $@
clean: do-clean
do-clean:
	dh_testdir
	dh_testroot
	[ ! -f Makefile ] || $(MAKE) DESTDIR=$(CURDIR)/debian/$(PKG_NAME) clean
	dh_clean
install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) install DESTDIR=debian/$(PKG_NAME)
binary-indep: build install
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs changelog
	dh_installdocs
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure patch unpatch do-clean

=== debian/watch ===
version=3
http://code.google.com/p/eiskaltdc/downloads/list .*name=eiskaltdcpp-(.+)\.tar\.bz2.* \
debian uupdate
